<?php

namespace FiloBlu\CustomReindex\Controller\Adminhtml\Indexer;

class MassReindexData extends \Magento\Backend\App\Action
{
    protected function _isAllowed()
    {
        if ($this->_request->getActionName() == 'massReindexData') {
            return $this->_authorization->isAllowed('FiloBlu_CustomReindex::customreindex');
        }
        return false;
    }
    
	public function execute()
    {
        $indexerIds = $this->getRequest()->getParam('indexer_ids');
        if (!is_array($indexerIds)) {
            $this->messageManager->addError(__('Please select indexers.'));
        } else {
            foreach ($indexerIds as $indexerId) {
            	try {
                    $indexer = $this->_objectManager->get('Magento\Framework\Indexer\IndexerRegistry')->get($indexerId);
                    $indexer->getState()
                        ->setStatus(\Magento\Framework\Indexer\StateInterface::STATUS_INVALID)
                        ->save();
                } catch (\Magento\Framework\Exception\LocalizedException $e) {
	                $this->messageManager->addError(
                        $indexer->getTitle() . ' indexer process unknown error:',
                        $e
                    );
	            } catch (\Exception $e) {
                    $this->messageManager->addException(
                        $e,
                        __("We couldn't reindex data because of an error.")
                    );
	            }
            }
            $this->messageManager->addSuccess(
                __('%1 indexer(s) have been invalidate successfully giovanotto/a ', count($indexerIds))
            );
        }
        $this->_redirect('indexer/indexer/list');
    }
}
